Index: /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/Index.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/Index.cs	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/Index.cs	(revision 15509)
@@ -26,6 +26,6 @@
   [NonDiscoverableType]
   internal sealed class Index<T> where T : class {
-    private Dictionary<T, uint> indexes;
-    private Dictionary<uint, T> values;
+    private readonly Dictionary<T, uint> indexes;
+    private readonly Dictionary<uint, T> values;
     private uint nextIndex;
 
@@ -35,6 +35,6 @@
       nextIndex = 1;
     }
-    public Index(IEnumerable<T> values)
-      : this() {
+
+    public Index(IEnumerable<T> values) : this() {
       foreach (var value in values) {
         this.indexes.Add(value, nextIndex);
@@ -54,7 +54,9 @@
       return index;
     }
+
     public T GetValue(uint index) {
       return index == 0 ? null : values[index];
     }
+
     public IEnumerable<T> GetValues() {
       return values.Values;
Index: /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/Mapper.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/Mapper.cs	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/Mapper.cs	(revision 15509)
@@ -23,5 +23,5 @@
 using System.Collections.Generic;
 using System.Linq;
-using Google.ProtocolBuffers;
+using Google.Protobuf;
 
 namespace HeuristicLab.Persistence {
@@ -43,5 +43,5 @@
     }
 
-    private static StaticCache staticCache = null;
+    private static StaticCache staticCache;
     private static object locker = new object();
     public static StaticCache StaticCache {
@@ -56,46 +56,72 @@
     private Index<ITransformer> transformers;
     private Index<Type> types;
-    private Index<string> strings;
+
     private Dictionary<uint, Box> boxId2Box;
     private Dictionary<object, uint> object2BoxId;
-    private Dictionary<uint, object> boxId2object;
+    private Dictionary<uint, object> boxId2Object;
+    private Index<TypeBox> typeBoxes;
+
+    private Index<string> strings;
+
+    private Index<BoolArrayBox> boolArrayBoxes;
+    private Index<IntArrayBox> intArrayBoxes;
+    private Index<UnsignedIntArrayBox> unsignedIntArrayBoxes;
+    private Index<LongArrayBox> longArrayBoxes;
+    private Index<UnsignedLongArrayBox> unsignedLongArrayBoxes;
+    private Index<FloatArrayBox> floatArrayBoxes;
+    private Index<DoubleArrayBox> doubleArrayBoxes;
+
+    private Index<DictionaryBox> dictionaryBoxes;
+    private Index<StorableClassBox> storableClassBoxes;
 
     public uint BoxCount { get; private set; }
+
 
     public Mapper() {
       transformers = new Index<ITransformer>();
       types = new Index<Type>();
-      strings = new Index<string>();
+
       boxId2Box = new Dictionary<uint, Box>();
       object2BoxId = new Dictionary<object, uint>(new MappingEqualityComparer());
-      boxId2object = new Dictionary<uint, object>();
+      boxId2Object = new Dictionary<uint, object>();
+      typeBoxes = new Index<TypeBox>();
+
+      strings = new Index<string>();
+
+      boolArrayBoxes = new Index<BoolArrayBox>();
+      intArrayBoxes = new Index<IntArrayBox>();
+      unsignedIntArrayBoxes = new Index<UnsignedIntArrayBox>();
+      longArrayBoxes = new Index<LongArrayBox>();
+      unsignedLongArrayBoxes = new Index<UnsignedLongArrayBox>();
+      floatArrayBoxes = new Index<FloatArrayBox>();
+      doubleArrayBoxes = new Index<DoubleArrayBox>();
+
+      dictionaryBoxes = new Index<DictionaryBox>();
+      storableClassBoxes = new Index<StorableClassBox>();
 
       BoxCount = 0;
     }
 
+    #region Transformers
     public uint GetTransformerId(ITransformer transformer) {
       return transformers.GetIndex(transformer);
     }
+
     public ITransformer GetTransformer(uint transformerId) {
       return transformers.GetValue(transformerId);
     }
-
+    #endregion
+
+    #region Types
     public uint GetTypeId(Type type) {
       return types.GetIndex(type);
     }
+
     public Type GetType(uint typeId) {
       return types.GetValue(typeId);
     }
-
-    public uint GetStringId(string str) {
-      return strings.GetIndex(str);
-    }
-    public string GetString(uint stringId) {
-      return strings.GetValue(stringId);
-    }
-
-    public Box GetBox(uint boxId) {
-      return boxId2Box[boxId];
-    }
+    #endregion
+
+    #region Boxes
     public uint GetBoxId(object o) {
       uint boxId;
@@ -115,7 +141,12 @@
       return boxId;
     }
+
+    public Box GetBox(uint boxId) {
+      return boxId2Box[boxId];
+    }
+
     public object GetObject(uint boxId) {
       object o;
-      if (boxId2object.TryGetValue(boxId, out o)) return o;
+      if (boxId2Object.TryGetValue(boxId, out o)) return o;
 
       Box box;
@@ -127,9 +158,72 @@
         var transformer = transformers.GetValue(box.TransformerId);
         o = transformer.ToObject(box, this);
-        boxId2object.Add(boxId, o);
+        boxId2Object.Add(boxId, o);
         transformer.FillFromBox(o, box, this);
       }
+
       return o;
     }
+
+    #region Referenced Boxes
+    #region TypeBoxes
+    public uint GetTypeBoxId(TypeBox typeBox) { return typeBoxes.GetIndex(typeBox); }
+    public TypeBox GetTypeBox(uint typeBoxId) { return typeBoxes.GetValue(typeBoxId); }
+    #endregion
+
+    #region BoolArrayBox
+    public uint GetBoolArrayBoxId(BoolArrayBox boolArrayBox) { return boolArrayBoxes.GetIndex(boolArrayBox); }
+    public BoolArrayBox GetBoolArrayBox(uint boolArrayBoxId) { return boolArrayBoxes.GetValue(boolArrayBoxId); }
+    #endregion
+
+    #region IntArrayBox
+    public uint GetIntArrayBoxId(IntArrayBox intArrayBox) { return intArrayBoxes.GetIndex(intArrayBox); }
+    public IntArrayBox GetIntArrayBox(uint intArrayBoxId) { return intArrayBoxes.GetValue(intArrayBoxId); }
+    #endregion
+
+    #region UnsignedIntArrayBox
+    public uint GetUnsignedIntArrayBoxId(UnsignedIntArrayBox unsignedIntArrayBox) { return unsignedIntArrayBoxes.GetIndex(unsignedIntArrayBox); }
+    public UnsignedIntArrayBox GetUnsignedIntArrayBox(uint unsignedIntArrayBoxId) { return unsignedIntArrayBoxes.GetValue(unsignedIntArrayBoxId); }
+    #endregion
+
+    #region LongArrayBox
+    public uint GetLongArrayBoxId(LongArrayBox longArrayBox) { return longArrayBoxes.GetIndex(longArrayBox); }
+    public LongArrayBox GetLongArrayBox(uint longArrayBoxId) { return longArrayBoxes.GetValue(longArrayBoxId); }
+    #endregion
+
+    #region UnsignedLongArrayBox
+    public uint GetUnsignedLongArrayBoxId(UnsignedLongArrayBox unsignedLongArrayBox) { return unsignedLongArrayBoxes.GetIndex(unsignedLongArrayBox); }
+    public UnsignedLongArrayBox GetUnsignedLongArrayBox(uint unsignedLongArrayBoxId) { return unsignedLongArrayBoxes.GetValue(unsignedLongArrayBoxId); }
+    #endregion
+
+    #region FloatArrayBox
+    public uint GetFloatArrayBoxId(FloatArrayBox floatArrayBox) { return floatArrayBoxes.GetIndex(floatArrayBox); }
+    public FloatArrayBox GetFloatArrayBox(uint floatArrayBoxId) { return floatArrayBoxes.GetValue(floatArrayBoxId); }
+    #endregion
+
+    #region DoubleArrayBox
+    public uint GetDoubleArrayBoxId(DoubleArrayBox doubleArrayBox) { return doubleArrayBoxes.GetIndex(doubleArrayBox); }
+    public DoubleArrayBox GetDoubleArrayBox(uint doubleArrayBoxId) { return doubleArrayBoxes.GetValue(doubleArrayBoxId); }
+    #endregion
+
+    #region DictionaryBox
+    public uint GetDictionaryBoxId(DictionaryBox dictionaryBox) { return dictionaryBoxes.GetIndex(dictionaryBox); }
+    public DictionaryBox GetDictionaryBox(uint dictionaryBoxId) { return dictionaryBoxes.GetValue(dictionaryBoxId); }
+    #endregion
+
+    #region StorableClassBox
+    public uint GetStorableClassBoxId(StorableClassBox storableClassBox) { return storableClassBoxes.GetIndex(storableClassBox); }
+    public StorableClassBox GetStorableClassBox(uint storableClassBoxId) { return storableClassBoxes.GetValue(storableClassBoxId); }
+    #endregion
+    #endregion
+    #endregion
+
+    #region Strings
+    public uint GetStringId(string str) {
+      return strings.GetIndex(str);
+    }
+    public string GetString(uint stringId) {
+      return strings.GetValue(stringId);
+    }
+    #endregion
 
     public object CreateInstance(Type type) {
@@ -143,18 +237,49 @@
     public static Bundle ToBundle(object o) {
       var mapper = new Mapper();
-      var bundle = Bundle.CreateBuilder();
+      var bundle = new Bundle();
+
       bundle.RootBoxId = mapper.GetBoxId(o);
-      bundle.AddRangeTransformerGuids(mapper.transformers.GetValues().Select(x => x.Guid).Select(x => ByteString.CopyFrom(x.ToByteArray())));
-      bundle.AddRangeTypeGuids(mapper.types.GetValues().Select(x => ByteString.CopyFrom(StaticCache.GetGuid(x).ToByteArray())));
-      bundle.AddRangeStrings(mapper.strings.GetValues());
-      bundle.AddRangeBoxes(mapper.boxId2Box.OrderBy(x => x.Key).Select(x => x.Value));
-      return bundle.Build();
+      bundle.TransformerGuids.AddRange(mapper.transformers.GetValues().Select(x => x.Guid).Select(x => ByteString.CopyFrom(x.ToByteArray())));
+      bundle.TypeGuids.AddRange(mapper.types.GetValues().Select(x => ByteString.CopyFrom(StaticCache.GetGuid(x).ToByteArray())));
+      bundle.Boxes.AddRange(mapper.boxId2Box.OrderBy(x => x.Key).Select(x => x.Value));
+      bundle.TypeBoxes.AddRange(mapper.typeBoxes.GetValues());
+
+      bundle.Strings.AddRange(mapper.strings.GetValues());
+
+      bundle.BoolArrayBoxes.AddRange(mapper.boolArrayBoxes.GetValues());
+      bundle.IntArrayBoxes.AddRange(mapper.intArrayBoxes.GetValues());
+      bundle.UnsignedIntArrayBoxes.AddRange(mapper.unsignedIntArrayBoxes.GetValues());
+      bundle.LongArrayBoxes.AddRange(mapper.longArrayBoxes.GetValues());
+      bundle.UnsignedLongArrayBoxes.AddRange(mapper.unsignedLongArrayBoxes.GetValues());
+      bundle.FloatArrayBoxes.AddRange(mapper.floatArrayBoxes.GetValues());
+      bundle.DoubleArrayBoxes.AddRange(mapper.doubleArrayBoxes.GetValues());
+
+      bundle.DictionaryBoxes.AddRange(mapper.dictionaryBoxes.GetValues());
+      bundle.StorableClassBoxes.AddRange(mapper.storableClassBoxes.GetValues());
+
+      return bundle;
     }
     public static object ToObject(Bundle bundle) {
       var mapper = new Mapper();
-      mapper.types = new Index<Type>(bundle.TypeGuidsList.Select(x => StaticCache.GetType(new Guid(x.ToByteArray()))));
-      mapper.strings = new Index<string>(bundle.StringsList);
-      mapper.boxId2Box = bundle.BoxesList.Select((b, i) => new { Box = b, Index = i }).ToDictionary(k => (uint)k.Index + 1, v => v.Box);
-      mapper.transformers = new Index<ITransformer>(bundle.TransformerGuidsList.Select(x => new Guid(x.ToByteArray())).Select(x => StaticCache.GetTransformer(x)));
+
+      mapper.transformers = new Index<ITransformer>(bundle.TransformerGuids.Select(x => new Guid(x.ToByteArray())).Select(StaticCache.GetTransformer));
+      mapper.types = new Index<Type>(bundle.TypeGuids.Select(x => StaticCache.GetType(new Guid(x.ToByteArray()))));
+
+      mapper.boxId2Box = bundle.Boxes.Select((b, i) => new { Box = b, Index = i }).ToDictionary(k => (uint)k.Index + 1, v => v.Box);
+      mapper.typeBoxes = new Index<TypeBox>(bundle.TypeBoxes);
+
+      mapper.strings = new Index<string>(bundle.Strings);
+
+      mapper.boolArrayBoxes = new Index<BoolArrayBox>(bundle.BoolArrayBoxes);
+      mapper.intArrayBoxes = new Index<IntArrayBox>(bundle.IntArrayBoxes);
+      mapper.unsignedIntArrayBoxes = new Index<UnsignedIntArrayBox>(bundle.UnsignedIntArrayBoxes);
+      mapper.longArrayBoxes = new Index<LongArrayBox>(bundle.LongArrayBoxes);
+      mapper.unsignedLongArrayBoxes = new Index<UnsignedLongArrayBox>(bundle.UnsignedLongArrayBoxes);
+      mapper.floatArrayBoxes = new Index<FloatArrayBox>(bundle.FloatArrayBoxes);
+      mapper.doubleArrayBoxes = new Index<DoubleArrayBox>(bundle.DoubleArrayBoxes);
+
+      mapper.dictionaryBoxes = new Index<DictionaryBox>(bundle.DictionaryBoxes);
+      mapper.storableClassBoxes = new Index<StorableClassBox>(bundle.StorableClassBoxes);
+
       return mapper.GetObject(bundle.RootBoxId);
     }
Index: /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/ProtoBufSerializer.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/ProtoBufSerializer.cs	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/ProtoBufSerializer.cs	(revision 15509)
@@ -21,13 +21,16 @@
 
 using System.IO;
+using Google.Protobuf;
 
 namespace HeuristicLab.Persistence {
   public sealed class ProtoBufSerializer : Serializer {
     protected override void SerializeBundle(Bundle bundle, Stream stream) {
-      bundle.WriteTo(stream);
+      using (var outputStream = new CodedOutputStream(stream))
+        bundle.WriteTo(outputStream);
     }
 
     protected override Bundle DeserializeBundle(Stream stream) {
-      return Bundle.ParseFrom(stream, Mapper.StaticCache.GetExtensionRegistry());
+      using (var inputStream = new CodedInputStream(stream))
+        return Bundle.Parser.ParseFrom(inputStream);
     }
   }
Index: /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StaticCache.cs
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StaticCache.cs	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Core/StaticCache.cs	(revision 15509)
@@ -25,17 +25,15 @@
 using System.Drawing;
 using System.Linq;
-using Google.ProtocolBuffers;
 using HeuristicLab.PluginInfrastructure;
 
 namespace HeuristicLab.Persistence {
   public sealed class StaticCache {
-    private static object locker = new object();
+    private static readonly object locker = new object();
 
-    private Dictionary<Guid, ITransformer> guid2Transformer;
-    private Dictionary<ITransformer, Guid> transformer2Guid;
-    private Dictionary<Guid, Type> guid2Type;
-    private Dictionary<Type, Guid> type2Guid;
-    private Dictionary<Type, TypeInfo> typeInfos;
-    private ExtensionRegistry extensionRegistry;
+    private readonly Dictionary<Guid, ITransformer> guid2Transformer;
+    private readonly Dictionary<ITransformer, Guid> transformer2Guid;
+    private readonly Dictionary<Guid, Type> guid2Type;
+    private readonly Dictionary<Type, Guid> type2Guid;
+    private readonly Dictionary<Type, TypeInfo> typeInfos;
 
     internal StaticCache() {
@@ -45,5 +43,4 @@
       type2Guid = new Dictionary<Type, Guid>();
       typeInfos = new Dictionary<Type, TypeInfo>();
-      extensionRegistry = ExtensionRegistry.CreateInstance();
 
       foreach (var transformer in ApplicationManager.Manager.GetInstances<ITransformer>())
@@ -82,23 +79,9 @@
       RegisterType(new Guid("E84C326A-7E14-4F28-AEFF-BC16CC671655"), typeof(KeyValuePair<,>));
       RegisterType(new Guid("F0280B55-25E8-4981-B309-D675D081402A"), typeof(string));
-      // 
+
       RegisterType(new Guid("9CF55419-439B-4A90-B2ED-8C7F7768EB61"), typeof(Array));
-      // RegisterType(new Guid("D15AD28B-203A-460E-815C-F7230C4B1F75"), typeof(bool[]));
-      // RegisterType(new Guid("EE318DC4-580D-4DB1-9AAD-988B0E50A3DB"), typeof(byte[]));
-      // RegisterType(new Guid("326B9484-361F-46F8-B8A6-46C781A8C51F"), typeof(sbyte[]));
-      // RegisterType(new Guid("C854783D-4C91-43C8-A19A-F96012494F8A"), typeof(short[]));
-      // RegisterType(new Guid("C47FB329-2A1D-4EB7-AFB1-1CF72AB30E98"), typeof(ushort[]));
-      // RegisterType(new Guid("9681D044-B50C-4907-B23E-BDFEBC6C3FFC"), typeof(char[]));
-      // RegisterType(new Guid("0FC62D91-D63F-4507-8696-885D4C07285A"), typeof(int[]));
-      // RegisterType(new Guid("C43A25A0-9B99-4DA4-9279-7495FE10428E"), typeof(uint[]));
-      // RegisterType(new Guid("7AC4DDAC-0E13-428E-BF49-7BE7B76746CB"), typeof(long[]));
-      // RegisterType(new Guid("8D9283A7-FE49-4AEA-A09F-D53CF3BE520A"), typeof(ulong[]));
-      // RegisterType(new Guid("BB9CFA0B-DD29-4C44-85C6-3A6289C55448"), typeof(float[]));
-      // RegisterType(new Guid("3B3AA69E-1641-4202-AE1D-7EEFF60FA355"), typeof(double[]));
-      // RegisterType(new Guid("7DF325A6-2553-4915-B7C6-D98191107CB7"), typeof(string[]));
-
-      RegisterType(new Guid("E451A99B-0CFD-48E6-9BEF-0AE9D1E73628"), typeof(IList));
       RegisterType(new Guid("B7313EE2-045F-41C9-AEC9-7B1A8CDBF90F"), typeof(IEnumerable));
       RegisterType(new Guid("D5265599-7380-4A28-AB0D-9F336EF290C5"), typeof(IEnumerable<>));
+      RegisterType(new Guid("E451A99B-0CFD-48E6-9BEF-0AE9D1E73628"), typeof(IList));
       RegisterType(new Guid("DB2A785C-5803-42C7-A01F-E1FD845A83A1"), typeof(List<>));
       RegisterType(new Guid("EB98A564-BEDC-458A-9E9B-4BF3CDAFB9BE"), typeof(Stack<>));
@@ -129,4 +112,5 @@
         }
       }
+
       RegisterType(new Guid("67C35B3B-DC23-4929-9BA9-0A0CD5FE17F5"), allTypes["System.StringComparer"]);
       RegisterType(new Guid("C7FDE8F0-EF3F-4A4D-8D87-5559C32A8B90"), allTypes["System.CultureAwareComparer"]);
@@ -151,46 +135,5 @@
       RegisterType(new Guid("00C8C940-63D9-43FF-99BA-9C69301BF043"), allTypes["System.Collections.Generic.RandomizedObjectEqualityComparer"]);
       RegisterType(new Guid("DAF22757-7FCC-49AC-B148-F3DD7E9E0A3B"), allTypes["System.Collections.Generic.IEqualityComparer`1"]);
-
-      //var registeredTypes = type2Guid.Keys.ToArray();
-      //foreach (var t in registeredTypes) {
-      //  AddBaseTypesRec(t);
-      //}
-
-      RegisterExtension(BoolBox.Bool);
-      RegisterExtension(IntBox.Int);
-      RegisterExtension(LongBox.Long);
-      RegisterExtension(UnsignedIntBox.UnsignedInt);
-      RegisterExtension(UnsignedLongBox.UnsignedLong);
-      RegisterExtension(FloatBox.Float);
-      RegisterExtension(DoubleBox.Double);
-      RegisterExtension(StringBox.String);
-      RegisterExtension(BytesBox.Bytes);
-      RegisterExtension(BoolArrayBox.BoolArray);
-      RegisterExtension(ByteArrayBox.ByteArray);
-      RegisterExtension(IntArrayBox.IntArray);
-      RegisterExtension(LongArrayBox.LongArray);
-      RegisterExtension(UnsignedIntArrayBox.UnsignedIntArray);
-      RegisterExtension(UnsignedLongArrayBox.UnsignedLongArray);
-      RegisterExtension(FloatArrayBox.FloatArray);
-      RegisterExtension(DoubleArrayBox.DoubleArray);
-      RegisterExtension(StringArrayBox.StringArray);
-      RegisterExtension(MatrixBox.Matrix);
-      RegisterExtension(BoolMatrixBox.BoolMatrix);
-      RegisterExtension(IntMatrixBox.IntMatrix);
-      RegisterExtension(DictionaryBox.Dictionary);
-      RegisterExtension(StorableClassBox.StorableClass);
-      RegisterExtension(TypeBox.Type);
     }
-
-    //private void AddBaseTypesRec(MemberSelection t) {
-    //  foreach (var interfaceType in t.GetInterfaces()) {
-    //    RegisterTypeAndFullName(interfaceType);
-    //    AddBaseTypesRec(interfaceType);
-    //  }
-    //  if (t.BaseType != null) {
-    //    RegisterTypeAndFullName(t.BaseType);
-    //    AddBaseTypesRec(t.BaseType);
-    //  }
-    //}
 
     public void RegisterTransformer(ITransformer transformer) {
@@ -206,4 +149,5 @@
       }
     }
+
     // mainly for testing
     public void DeregisterType(Guid guid) {
@@ -213,31 +157,21 @@
       }
     }
-    //public void RegisterTypeAndFullName(MemberSelection type) {
-    //  lock (locker) {
-    //    var key = type.AssemblyQualifiedName ?? type.Name;
-    //    if (!guid2Type.ContainsKey(key)) {
-    //      guid2Type.Add(key, type);
-    //      type2Guid.Add(type, key);
-    //    }
-    //  }
-    //}
-    public void RegisterExtension<TExtension>(GeneratedExtensionBase<TExtension> extension) {
-      lock (locker) {
-        extensionRegistry.Add(extension);
-      }
-    }
 
     public ITransformer GetTransformer(Guid guid) {
       return guid2Transformer[guid];
     }
+
     public Guid GetGuid(ITransformer transformer) {
       return transformer2Guid[transformer];
     }
+
     public Type GetType(Guid guid) {
       return guid2Type[guid];
     }
+
     public Guid GetGuid(Type type) {
       return type2Guid[type];
     }
+
     public TypeInfo GetTypeInfo(Type type) {
       lock (locker) {
@@ -245,5 +179,5 @@
         if (!typeInfos.TryGetValue(type, out typeInfo)) {
           var transformer = guid2Transformer.Values.OrderBy(x => x.Priority).FirstOrDefault(x => x.CanTransformType(type));
-          if(transformer == null) throw new PersistenceException("No transformer found for type " + type.AssemblyQualifiedName);
+          if (transformer == null) throw new PersistenceException("No transformer found for type " + type.AssemblyQualifiedName);
           typeInfo = new TypeInfo(type, transformer);
           typeInfos.Add(type, typeInfo);
@@ -252,7 +186,4 @@
       }
     }
-    public ExtensionRegistry GetExtensionRegistry() {
-      return extensionRegistry;
-    }
   }
 }
Index: /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/HeuristicLab.Persistence-4.0.csproj
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/HeuristicLab.Persistence-4.0.csproj	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/HeuristicLab.Persistence-4.0.csproj	(revision 15509)
@@ -73,5 +73,4 @@
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Protos\PersistenceMessages.cs" />
-    <Compile Include="Transformers\StorableClassTransformer.cs" />
     <Compile Include="Transformers\Transformers.cs" />
   </ItemGroup>
Index: /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Protos/PersistenceMessages.proto
===================================================================
--- /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Protos/PersistenceMessages.proto	(revision 15508)
+++ /branches/PersistenceReintegration/HeuristicLab.Persistence/4.0/Protos/PersistenceMessages.proto	(revision 15509)
@@ -9,31 +9,18 @@
   uint32 root_box_id = 10;
   repeated Box boxes = 20;
+  repeated TypeBox type_boxes = 30;
 
   repeated string strings = 100;
-  repeated bool bools = 101;
-  repeated int32 ints = 102;
-  repeated int64 longs = 103;
-  repeated uint32 uints = 104;
-  repeated uint64 ulongs = 105;
-  repeated float floats = 106;
-  repeated double doubles = 107;
-  repeated bytes bytes = 108;
 
-  repeated StringArrayBox string_arrays = 200;
-  repeated BoolArrayBox bool_arrays = 201;
-  repeated IntArrayBox int_arrays = 202;
-  repeated LongArrayBox long_arrays = 203;
-  repeated UnsignedIntArrayBox uint_arrays = 204;
-  repeated UnsignedLongArrayBox ulong_arrays = 205;
-  repeated FloatArrayBox float_arrays = 206;
-  repeated DoubleArrayBox double_arrays = 207;
-  repeated ByteArrayBox byte_arrays = 208;
-
-  repeated MatrixBox matrices = 300;
-  repeated BoolMatrixBox bool_matrices = 310;
-  repeated IntMatrixBox int_matrices = 311;
-
-  repeated DictionaryBox dictionaries = 400;
-  repeated StorableClassBox storables = 410;
+  repeated BoolArrayBox bool_array_boxes = 200;
+  repeated IntArrayBox int_array_boxes = 201;
+  repeated UnsignedIntArrayBox unsigned_int_array_boxes = 203;
+  repeated LongArrayBox long_array_boxes = 202;
+  repeated UnsignedLongArrayBox unsigned_long_array_boxes = 204;
+  repeated FloatArrayBox float_array_boxes = 205;
+  repeated DoubleArrayBox double_array_boxes = 206;
+  
+  repeated DictionaryBox dictionary_boxes = 300;
+  repeated StorableClassBox storable_class_boxes = 310;
 }
 message Box {
@@ -41,11 +28,13 @@
   uint32 type_id = 2;
   uint32 box_id = 3;
+
   bool bool = 10;
   int32 int = 11;
   int64 long = 12;
-  uint32 uint = 13;
-  uint64 ulong = 14;
+  uint32 u_int = 13;
+  uint64 u_long = 14;
   float float = 15;
   double double = 16;
+  bytes bytes = 17;
 }
 message TypeBox {
@@ -63,5 +52,4 @@
 message FloatArrayBox { repeated float values = 1; }
 message DoubleArrayBox { repeated double values = 1; }
-message ByteArrayBox { bytes values = 1; }
 
 // matrix boxes
